package com.bcxin.saas.core.logs;

import lombok.Getter;
import org.slf4j.event.Level;

import java.io.Serializable;

@Getter
public class LoggerEventMessage implements Serializable {
    private final String category;
    private final String name;
    private final String message;
    private final Object params;
    private final Level level;

    public LoggerEventMessage(String category, String name, String message, Object params, Level level) {
        this.category = category;
        this.name = name;
        this.message = message;
        this.params = params;
        this.level = level;
    }

    public static LoggerEventMessage create(String category, String name, String message, Object params, Level level) {
        return new LoggerEventMessage(category, name, message, params, level);
    }
}
