package com.bcxin.saas.core.utils;

import java.util.Collection;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.stream.Collectors;

public class CompleteFurtherUtils {
    public static <T> void execute(Collection<T> collection, Consumer<T> consumer) {
        ExecutorService executor = Executors.newFixedThreadPool(5);
        try {

            Collection<CompletableFuture<Void>> futures =
                    collection.stream()
                            .map(key -> {
                                return CompletableFuture.runAsync(() -> {
                                    consumer.accept(key);
                                    return;
                                }, executor);
                            }).collect(Collectors.toList());

            CompletableFuture<Void> allCF = CompletableFuture.allOf(futures.toArray(new CompletableFuture[0]));

            Object result = allCF.join();
        } finally {
            executor.shutdown();
        }
    }

    /*
    public static <T,R> Collection<R> execute(Collection<T> collection, Function<T,R> consumer) {
        ExecutorService executor = Executors.newFixedThreadPool(5);
        try {

            Collection<CompletableFuture<R>> futures =
                    collection.stream()
                            .map(key -> {
                                return CompletableFuture.supplyAsync(() -> {
                                    return consumer.apply(key);
                                }, executor);
                            }).collect(Collectors.toList());

            CompletableFuture<Void> allCF = CompletableFuture.allOf(futures.toArray(new CompletableFuture[0]));

            Object result = allCF.join();

            return result;
        } finally {
            executor.shutdown();
        }
    }

     */
}
