package com.bcxin.saas.core.utils;

import cn.hutool.core.util.StrUtil;

import java.util.ArrayList;
import java.util.stream.Collectors;

public class ComponentUtils {
    private static ArrayList<String> staticResourceArray = new ArrayList();
    public final static String specialUploadPath = "/uploads/item/";
    static {
        staticResourceArray.add(".png");
        staticResourceArray.add(".jpg");
        staticResourceArray.add(".jpeg");
        staticResourceArray.add(".gif");
        staticResourceArray.add(".ico");
        staticResourceArray.add("/images/");
        staticResourceArray.add(specialUploadPath);
        staticResourceArray.add("/uploads/lib/");
        staticResourceArray.add(".zip");
        staticResourceArray.add(".rar");
        staticResourceArray.add(".pdf");
        staticResourceArray.add(".docx");
        staticResourceArray.add(".doc");
        staticResourceArray.add(".js");
        staticResourceArray.add(".css");
        staticResourceArray.add(".html");
        staticResourceArray.add(".xls");
        staticResourceArray.add(".swf");
        staticResourceArray.add(".txt");
        staticResourceArray.add(".exe");
        staticResourceArray.add(".xls");
        staticResourceArray.add(".xlsx");
        staticResourceArray.add("actuator/health");
        staticResourceArray.add("actuator/httptrace");
        staticResourceArray.add("actuator/metrics");
        staticResourceArray.add("/v2/sync/");
        staticResourceArray.add("/v2/sync/");
        staticResourceArray.add("/v3/extends/");
        staticResourceArray.add("/api/v2/runtime");
        staticResourceArray.add("/druid/");
    }

    public static boolean isFilterIgnored(String uri) {
        if (StrUtil.isBlank(uri)) {
            return false;
        }
        if (staticResourceArray.stream().anyMatch(ii -> {
            return StrUtil.containsAny(uri, ii);
        })) {
            return true;
        }

        return false;
    }

    public static String getExclusions() {
        return staticResourceArray.stream().map(ii -> String.format("*.%s", ii)).collect(Collectors.joining(","));
    }
}
